import os, sys, glob
v1,v2,v3 = sys.version_info[:3]
if 10*v1 + v2 < 24:
  print "Please install Python 2.4 or higher"
  sys.exit()
  
currdir = os.path.split(os.path.abspath(__file__))[0] + os.sep + ".."
chains = open(currdir+os.sep+"chains.list").readlines()
chains = [l.split()[:3] for l in chains if len(l.split()) >= 3]

for prot, chain1, chain2 in chains:
  for run in "run1", "run3":
    rundir = os.sep.join((currdir, prot, run))
    preddir = os.sep.join((currdir, prot, "predictions"))
    cport1 = open(os.sep.join((preddir, prot+ chain1+ ".cport"))).readlines()    
    predcount1 = len([l for l in cport1 if len(l.strip())])
    cport2 = open(os.sep.join((preddir, prot+ chain2+ ".cport"))).readlines()
    predcount2 = len([l for l in cport2 if len(l.strip())])
    if not os.path.exists(rundir): continue
    for it in "it0", "it1", "water":
      itdir = os.sep.join((rundir, it))
      if not os.path.exists(itdir): continue
      print prot, run, it
      filenam = os.sep.join((itdir, "file.nam"))
      files = open(filenam).read().splitlines()[:400]
      counts1, counts2 = {}, {}
      wrong = False
      for f in files:
        ff = os.sep.join((itdir, f.strip()[:-4]+".contacts"))	
	if not os.path.exists(ff):
	  wrong = True
	  break
        lines = open(ff).readlines()
	for l in lines:
	  ll = l.split()
	  if len(ll) < 7: continue
	  k1 = int(ll[0])
	  if k1 not in counts1: counts1[k1] = 0
	  counts1[k1] += 1
	  k2 = int(ll[3])
	  if k2 not in counts2: counts2[k2] = 0
	  counts2[k2] += 1
      if wrong: continue
      counts1 = zip(counts1.keys(), counts1.values())
      counts1.sort(key=lambda a: -a[1])
      tar = os.sep.join((preddir, prot+ chain1+ ".dockpred-" + run + "-" + it))
      open(tar, "w").write("\n".join([str(c[0]) for c in counts1[:predcount1]]))
      counts2 = zip(counts2.keys(), counts2.values())
      counts2.sort(key=lambda a: -a[1])
      tar = os.sep.join((preddir, prot+ chain2+ ".dockpred-" + run + "-" + it))
      open(tar, "w").write("\n".join([str(c[0]) for c in counts2[:predcount2]]))      
 
